#include <stdio.h>
#include <stdlib.h>
//#include <string>
#include <iostream>
#include <fstream>
using namespace std;

#include "MyClassIO.h"

const int kBufSize = 1024;

//______________________________________________________________________________
MyClassIO::MyClassIO()
{
//   cout << "---MyClassIO::MyClassIO()---------" << endl;
   printf("---MyClassIO::MyClassIO()---------\n");
}

//______________________________________________________________________________
MyClassIO::~MyClassIO()
{
//   cout << "---MyClassIO::~MyClassIO()---------" << endl;
   printf("---MyClassIO::~MyClassIO()---------\n");
}

//______________________________________________________________________________
void MyClassIO::ReadFileC(const char *infile)
{
//   cout << "------MyClassIO::ReadFileC------" << endl;
   printf("---MyClassIO::ReadFileC---------\n");

   char  nextline[kBufSize];
   char *str;

   FILE *input;
   input = fopen(infile, "r");
   if (!input) {
      printf("Error: Could not open input <%s>\n", infile);
      return;
   }//if

   // input header
   str = fgets(nextline, kBufSize, input);
   printf(str, "\n");

   // loop over data
   const int nentries = 20;
   for (int i=0; i<nentries; i++) {
      str = fgets(nextline, kBufSize, input);
      printf(str, "\n");
   }//for_i

   fclose(input);

   printf("<%d> records imported.\n", nentries);
}

//______________________________________________________________________________
void MyClassIO::ReadFileCpp(const char *infile)
{
//   cout << "------MyClassIO::ReadFileCCpp------" << endl;
   printf("---MyClassIO::ReadFileCpp---------\n");
//   std::cout << "------MyClassIO::ReadFileCpp------" << endl;

   char  nextline[kBufSize];
   char *str;
   char  delim = '\n';
   const char *sep = "\t";

   ifstream input;
   input.open(infile, ifstream::in);
   if (!input.good()) {
//      cerr << "Error: Could not create input <" << infile << ">" << endl;
      printf("Error: Could not create input <%s>\n", infile);
      return;
   }//if

   // input header
   input.getline(nextline, kBufSize, delim);
   str = strtok(nextline, sep);
   cout << str;
   for (int k=1; k<4; k++) {
      char *str = strtok(0, sep);
      if (str == 0) break;
      cout << sep << str;
   }//for_i
   cout << endl;

   // loop over data
   const int nentries = 20;
   for (int i=0; i<nentries; i++) {
      input.getline(nextline, kBufSize, delim);
      str = strtok(nextline, sep);
      cout << str;
      for (int k=1; k<4; k++) {
         char *str = strtok(0, sep);
         if (str == 0) break;
         cout << sep << str;
      }//for_i
      cout << endl;
   }//for_i

   input.close();

//   cout << "<" << nentries << "> records imported." << endl;
//   printf("<%d> records imported.\n", nentries);
}

//______________________________________________________________________________
void MyClassIO::WriteFileC(const char *outfile)
{
//   cout << "------MyClassIO::WriteFileC------" << endl;
   printf("---MyClassIO::WriteFileC---------\n");

   FILE *output;
   output = fopen(outfile, "w");
   if (!output) {
      printf("Error: Could not create output <%s>\n", outfile);
      return;
   }//if

   const char *sep = "\t";
   // output header
   fprintf(output, "TitleC_0");
   for (int k=1; k<4; k++) {
      fprintf(output, sep);
      fprintf(output, "TitleC_%d", k);
   }//for_k
   fprintf(output, "\n");

   // loop over data
   const int nentries = 20;
   for (int i=0; i<nentries; i++) {
      for (int k=0; k<4; k++) {
         if (k != 0) {fprintf(output, sep);}
         float data = static_cast<float>(k*i);
         fprintf(output, "%f", data);
      }//for_j
      fprintf(output, "\n");
   }//for_i
   fclose(output);

   printf("<%d> records exported.\n", nentries);
}

//______________________________________________________________________________
void MyClassIO::WriteFileCpp(const char *outfile)
{
//   cout << "------MyClassIO::WriteFileCpp------" << endl;
   printf("---MyClassIO::WriteFileCpp---------\n");
//   std::cout << "------MyClassIO::WriteFileCpp------" << endl;

   std::ofstream output(outfile);
//   ofstream output(outfile);
   if (!output) {
//      cerr << "Error: Could not create output <" << outfile << ">" << endl;
      printf("Error: Could not create output <%s>\n", outfile);
      return;
   }//if

//string s("str21");
//output << s << endl;

   const char *sep = "\t";
   // output header
   output << "TitleCpp_0";
   for (int k=1; k<4; k++) {
      output << sep
             << "TitleCpp_" << k;
   }//for_k
   output << std::endl;
//   output << endl;

   // loop over data
   const int nentries = 20;
   for (int i=0; i<nentries; i++) {
      for (int k=0; k<4; k++) {
         if (k != 0) {output << sep;}
         float data = static_cast<float>(k*i);
         output << data;
//?         output << fixed << data;
      }//for_j
      output << std::endl;
//      output << endl;
   }//for_i

   output.close();

//   cout << "<" << nentries << "> records exported." << endl;
//   printf("<%d> records exported.\n", nentries);
}

